%{!?ruby_sitelib: %define ruby_sitelib %(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")}
%{!?ruby_sitearch: %define ruby_sitearch %(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")}
%{!?httpd_modlib: %define httpd_modlib %(/usr/sbin/apxs -q LIBEXECDIR)}
%define realname passenger

Name:           mod_passenger
Version:        2.0.4
Release:        2%{?dist}
Summary:        Apache server module for deploying ruby-on-rails applications
Group:          Applications/Internet
License:        GPLv2
URL:            http://rubyforge.org/frs/download.php/41025/%{realname}-%{version}.tar.gz
Source0:        %{name}-%{version}.tar.gz
Source1:        mod_passenger.conf
Patch0:         mod_passenger-2.0.3-patch-path.append
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  ruby ruby-devel doxygen asciidoc rubygem-rake httpd-devel
Requires:       ruby(abi) = 1.8 httpd rubygem-rack rubygem-fastthread openssl

%description
Phusion Passenger is an Apache module, which makes deploying Ruby and Ruby on Rails applications on Apache a breeze. It follows the usual Ruby on Rails conventions, such as "Don't-Repeat-Yourself" and ease of setup, while at the same time providing enough flexibility.

%prep
%setup -q
%patch0 -p1 -b .path.append


%build
export CFLAGS="$RPM_OPT_FLAGS"
rake default
rake doc

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{ruby_sitelib}
mkdir -p $RPM_BUILD_ROOT/%{ruby_sitearch}/passenger
mkdir -p $RPM_BUILD_ROOT/%{_mandir}
mkdir -p $RPM_BUILD_ROOT/%{_docdir}/%{name}-%{version}
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d/

install -D $RPM_BUILD_DIR/%{name}-%{version}/ext/apache2/mod_passenger.so $RPM_BUILD_ROOT/%{httpd_modlib}/mod_passenger.so
install -D $RPM_BUILD_DIR/%{name}-%{version}/ext/apache2/ApplicationPoolServerExecutable $RPM_BUILD_ROOT/%{_libdir}/passenger/ApplicationPoolServerExecutable
install -D $RPM_BUILD_DIR/%{name}-%{version}/bin/passenger-spawn-server $RPM_BUILD_ROOT/%{_libdir}/passenger/passenger-spawn-server
install -D $RPM_BUILD_DIR/%{name}-%{version}/bin/passenger-config $RPM_BUILD_ROOT/%{_bindir}/passenger-config
install -D $RPM_BUILD_DIR/%{name}-%{version}/bin/passenger-stress-test $RPM_BUILD_ROOT/%{_bindir}/passenger-stress-test
install -D $RPM_BUILD_DIR/%{name}-%{version}/bin/passenger-make-enterprisey $RPM_BUILD_ROOT/%{_sbindir}/passenger-make-enterprisey
install -D $RPM_BUILD_DIR/%{name}-%{version}/bin/passenger-memory-stats $RPM_BUILD_ROOT/%{_sbindir}/passenger-memory-stats
install -D $RPM_BUILD_DIR/%{name}-%{version}/bin/passenger-status $RPM_BUILD_ROOT/%{_sbindir}/passenger-status
cp -a $RPM_BUILD_DIR/%{name}-%{version}/man/* $RPM_BUILD_ROOT/%{_mandir}/
cp -a $RPM_BUILD_DIR/%{name}-%{version}/benchmark $RPM_BUILD_ROOT/%{_docdir}/%{name}-%{version}/
cp -a $RPM_BUILD_DIR/%{name}-%{version}/doc/* $RPM_BUILD_ROOT/%{_docdir}/%{name}-%{version}/
cp -a $RPM_BUILD_DIR/%{name}-%{version}/lib/passenger $RPM_BUILD_ROOT/%{ruby_sitelib}
cp -a $RPM_BUILD_DIR/%{name}-%{version}/ext/passenger/native_support.so $RPM_BUILD_ROOT/%{ruby_sitearch}/passenger/
cp -a $RPM_BUILD_DIR/%{name}-%{version}/[A-Z][A-Z][A-Z]* $RPM_BUILD_ROOT/%{_docdir}/%{name}-%{version}/

sed -e "s#@ROOTDIR@#%{_libdir}/passenger#" < %{SOURCE1} > $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d/mod_passenger.conf

echo -n %{version} > $RPM_BUILD_ROOT/%{_sysconfdir}/passenger_version.txt

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc %{_docdir}/*
%doc %{_mandir}/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/*
%{ruby_sitelib}/*
%{ruby_sitearch}/*
%{httpd_modlib}/*
%{_bindir}/*
%{_sbindir}/*
%{_libdir}/passenger/*
%{_sysconfdir}/passenger_version.txt

%changelog
* Fri Jan 23 2009 Ralph Angenendt <ralph@centos.org> - 2.0.4-2
- bump version to 2.0.4
- fix "header problem" (passenger_version.txt)
* Fri Sep 12 2008 Ralph Angenendt <ralph@centos.org> - 2.0.3-1
- initial package
